//*********************************************************************
//  : MQ6825_I2C
// 汾     : V1.1 02/25/2021 MQ6825
//      : I2Cʹú
// ע     :
//*********************************************************************

#include "main.h"

User_I2C  Flow;
extern uchar wBuf[16];
//*********************************************************************
// 	: I2C_SetSlaveAddr
// 	: ôģʽַ
// ע		:
//*********************************************************************
void I2C_SetSlaveAddr(uchar addr)
{
	I2C0AR = addr & 0xfe;				// SA0[7:1]: Slave address setting
										// 0Xfe	1111 1110		
										// &0xfe   : and clear bit0  
}

//*********************************************************************
// 	: I2C_Init
// 	: OÁKI2C
// ע		: initial
//*********************************************************************
void I2C_Init(void)
{	//====== ܽųʼ ======
	P2CR_P3  = 0;						// 趨 P23 
	P2CR_P4  = 0;						// 趨 P24 
	//====== ܿ( Enable) ======
	POFFCR1_SBI0EN  = 1;				// ȿݴò,SBI0 Enable
	
	while( P2PRD_P3==0 || P2PRD_P4==0 ){// ȴΪߵλ
		CLR_WDT; 						// Źʱ (ι)
	}	
	//====== 趨 ======
    P2OUTCR_P2OUTCR3 = 1;               // P23 ˿ڿ©
    P2OUTCR_P2OUTCR4 = 1;               // P24 ˿ڿ©
	
	P2DR_P3    = 0; 				    //  P23 ͵ƽ
	P2DR_P4    = 0;						//  P24 ͵ƽ
	
	P2FC_P3    = 1;						// лP23Ϊ⹦ܽ
	P2FC_P4    = 1;						// лP24Ϊ⹦ܽ
	
	P2CR_P3    = 1; 					//  P23 Ϊ
	P2CR_P4    = 1; 					//  P24 Ϊ

//-----------------------------------------------------------------------
//------------bit7 | bit6 | bit5 | bit4  |  bit3  | bit2 | bit1~bit0 ----
//--- SBI0CR2 <MST>, <TRX>, <BB>, <PIN> and <SBIM>  <NA>   <SWRST>
//            <MST>   1 : Master
//                    0 : Slave
// 			  <TRX>   1 :    ; 0: 
// 			  <BB>    1 : ʼ
//       	          0 : ֹͣ
//			  <PIN>	  1 : ȡжϷ
//
//			  <SBIM>  1 : Serial bus interface mode(ģʽ) / 0:Port mode
//            <SWRST> ÿʼλ   	

	SBI0CR2 = 0x18;						// 0001 1000
	SBI0CR1 = 0x10;						// 0001 0000

}

//*********************************************************************
// 	: I2C_IntEnable
// 	: SI2CД
// ע		: ִкῪж(IMF)
//*********************************************************************
void I2C_IntEnable(void)
{
	DI;
	IL_INTSBI = 0;
	EI_INTSBI = 1;
	EI;
}


//*********************************************************************
// 	: I2C_IntDisable 
// 	: ֹI2CД
// ע		: ִкῪж(IMF)
//*********************************************************************
void I2C_IntDisable(void)
{
	DI;
	EI_INTSBI = 0;
	IL_INTSBI = 0;	
	EI;
}


//*********************************************************************
// 	: I2C_Start
// 	: _ʼl푑ַһֹ
// ע		:
//*********************************************************************
//------------bit7 | bit6 | bit5 | bit4  |  bit3  | bit2 | bit1~bit0 ----
//--- SBI0CR2 <MST>, <TRX>, <BB>, <PIN> and <SBIM>  <NA>   <SWRST>
//            <MST>   1 : Master
//                    0 : Slave
// 			  <TRX>   1 :    ; 0: 
// 			  <BB>    1 : ʼ
//       	          0 : ֹͣ
//			  <PIN>	  1 : ȡжϷ
//
//			  <SBIM>  1 : Serial bus interface mode(ģʽ) / 0:Port mode
//            <SWRST> ÿʼλ  

void I2C_Start(uchar data, uchar address)
{
	uchar tWait = 0;

	while( SBI0SR2_BB == 1 ){}			// SBI0SR2.BB: Bus status confirms is free ; 1 :busy  0: free

	SBI0CR1 = 0x10;						// ***ÿһ I2C_Start趨SBI0CR1
//****** Write data to the registers before the start condition is generated ******
	SBI0DBR = data;						// 趨 slave Device ID
	SBI0CR2 = 0xf8;						// Write "1" to SBI0CR2<MST>, <TRX>, <BB>, <PIN>  and <SBIM>to "1"
										// 1111 1000
										// Set master,,ʼ,ȡжϷ and ģʽ
	
	
	while( SBI0SR2_PIN == 1 ){}			// ȴbyte, PINΪ0	
	while( SBI0SR2_LRB == 1 ){			// check <LRB> յλ, ӻӦźACK									
		tWait++;						// Ӧ,  ==> SCKᱣ
		if( tWait>250 ){				// Ӧѭ		
			I2C_Stop();					// I2C stop -> release SCK
			break;
		}
	}

//... 趨 slave start address..................
	tWait = 0;
	SBI0DBR = address;					// 趨 slave start address
	while( SBI0SR2_PIN == 1 ){}			// ȴbyte, PINΪ0
	while( SBI0SR2_LRB == 1 ){			// check <LRB>  ӻӦźACK										
		tWait++;						// Ӧ,  ==> SCKһֱ
		if( tWait>250 ){				// Ӧѭ		
			I2C_Stop();					// I2C stop -> release SCK
			break;
		}
	}
}


//*********************************************************************
// 	: I2C_Restart 
// 	: Restart푑ַ
// ע		:
//*********************************************************************
//------------bit7 | bit6 | bit5 | bit4  |  bit3  | bit2 | bit1~bit0 ----
//--- SBI0CR2 <MST>, <TRX>, <BB>, <PIN> and <SBIM>  <NA>   <SWRST>
//            <MST>   1 : Master
//                    0 : Slave
// 			  <TRX>   1 :    ; 0: 
// 			  <BB>    1 : ʼ
//       	          0 : ֹͣ
//			  <PIN>	  1 : ȡжϷ
//
//			  <SBIM>  1 : Serial bus interface mode(ģʽ) / 0:Port mode
//            <SWRST> ÿʼλ  

void I2C_Restart(uchar data)
{
	uchar tWait = 0;

	SBI0CR2 = 0x18;						// 0001 1000
										// Set master,,ʼ,ȡжϷ and ģʽ
										
	while( SBI0SR2_BB == 1 ){}			// SBI0SR2.BB: Bus status confirms is free ; 1 :busy  0: free
	while( SBI0SR2_LRB == 0 ){}			// wait <LRB>=1**********************

//****** Write data to the registers before the start condition is generated ******
	SBI0DBR = data;
	SBI0CR2 = 0xf8;						// Write "1" to SBI0CR2<MST>, <TRX>, <BB>, <PIN>  and <SBIM>to "1"
	while( SBI0SR2_PIN == 1 ){}			// ȴbyte, PINΪ0
	while( SBI0SR2_LRB == 1 ){			// check <LRB>  ӻӦźACK										
		tWait++;						// Ӧ,  ==> SCKһֱ
		if( tWait>250 ){				// Ӧѭ		
			I2C_Stop();					// I2C stop -> release SCK
			break;
		}
	}
}


//*********************************************************************
// 	: I2C_Stop 
// 	: ֹͣl
// ע		:
//*********************************************************************
//------------bit7 | bit6 | bit5 | bit4  |  bit3  | bit2 | bit1~bit0 ----
//--- SBI0CR2 <MST>, <TRX>, <BB>, <PIN> and <SBIM>  <NA>   <SWRST>
//            <MST>   1 : Master
//                    0 : Slave
// 			  <TRX>   1 :    ; 0: 
// 			  <BB>    1 : ʼ
//       	          0 : ֹͣ
//			  <PIN>	  1 : ȡжϷ
//
//			  <SBIM>  1 : Serial bus interface mode(ģʽ) / 0:Port mode
//            <SWRST> ÿʼλ  

void I2C_Stop(void)
{
	SBI0CR2 = 0xd8;						// Set SBI0CR2<MST>, <TRX> and <PIN> to "1" and SBI0CR2<BB> to "0"
										// 1101 1000
										// Set master,,ֹͣ,ȡжϷ and Portģʽ
										
	while( SBI0SR2_BB == 1 ){}			// SBI0SR2.BB: Bus status confirms is free ; 1 :busy  0: free
}


//*********************************************************************
// 	: I2C_ByteWrite 
// 	: byte write * len
// ע		:
//*********************************************************************
void I2C_ByteWrite(uchar *data, uchar len)
{
	uchar i, tWait;

	for( i=0; i<len; i++ ){	
		tWait = 0;
		SBI0DBR = *data;
		data++;
		while( SBI0SR2_PIN == 1 ){}		// ȴbyte, PINΪ0
		while( SBI0SR2_LRB == 1 ){		// check <LRB>  ӻӦźACK	// Ӧ,  ==> SCKһֱ
			tWait++;	
			if( tWait>250 ){			// Ӧѭ			
				I2C_Stop();				// I2C stop -> release SCK
				break;
			}
		}
	}

}


//*********************************************************************
// 	: I2C_ByteRead 
// 	: byte read * len
// ע		:
//*********************************************************************
void I2C_ByteRead(uchar *data, uchar len)
{
	uchar i;

	len -= 1;
//...(len-1)byte..................
	for( i=0; i<len; i++ ){
		SBI0DBR   = 0x00;				// write dummy data to set PIN = 1
		while( SBI0SR2_PIN == 1 ){}		// ȴbyte, PINΪ0
		*data = SBI0DBR;
		data++;
	}

//...һbyte..................
	SBI0CR1_ACK = 0;					// ACK=0
	SBI0DBR   = 0x00;					// write dummy data to set PIN = 1
	while( SBI0SR2_PIN == 1 ){}			// ȴbyte, PINΪ0
	*data = SBI0DBR;

//	Termination of data transfer by master mode
//	Sent 1 bit negative acknowledge............
	SBI0CR1_BC = 1;						// BC, bit count = 1
	SBI0DBR   = 0x00;					// write dummy data to set PIN = 1
	while( SBI0SR2_PIN == 1 ){}			// ȴbyte, PINΪ0
}




//*********************************************************************
//   : IntSBI
//  : I2CД
// ע       :
//*********************************************************************
void __interrupt IntSBI(void)
{
    BIT_SBI0SR2 I2C_Flag;
    
    *((uchar *)(&I2C_Flag)) = SBI0SR2;
    
//----------------------------------------------------------//
//****** Receiver at slave mode ****************************//
//----------------------------------------------------------//
    if( I2C_Flag.TRX == 0 ){                            // TRX: Transmitter/Receiver selection status monitor.==> 0).Receiver, 1).Transmitter   
        if( I2C_Flag.AAS == 1 ){                        // AAS: Slave address match detection monitor       
            Flow.sFlag.match_addr = 1;                  // first address match detection
            Flow.iByte            = 0;
            Flow.sFlag.R1W0       = I2C_Flag.LRB;       // 1:read, 0:write.
            SBI0DBR               = 0;                  // Write the dummy data (0x00) to the SBI0DBR to set SBI0CR2<PIN> to "1"

        }
        else{       
            if( Flow.sFlag.match_addr == 1 ){           // get address first            
                Flow.iAddr_st             = SBI0DBR;
                Flow.iAddr_pt             = Flow.iAddr_st;
                Flow.iByte                = Flow.iAddr_st;
                Flow.sFlag.match_addr = 0;
                SBI0DBR              = 0;               // Write the dummy data (0x00) to the SBI0DBR to set SBI0CR2<PIN> to "1"
            }
            else{           
                wBuf[Flow.iByte] = SBI0DBR;             // get write data from master
                Flow.iByte++;
                Flow.iByte &= 0x0f;                     // max. 16 byte: then overwrite data at 1st has get
                SBI0DBR    = 0;                         // Write the dummy data (0x00) to the SBI0DBR to set SBI0CR2<PIN> to "1"
            }
        }
    }

//----------------------------------------------------------//
//****** Transmitter at slave mode *************************//
//----------------------------------------------------------//
    else
    {
        if( I2C_Flag.AAS == 1 ){                         // AAS: Slave address match detection monitor       
            SBI0DBR = wBuf[Flow.iByte];
            Flow.iByte++;
        }
        else{
            if( I2C_Flag.LRB == 1 ){                     // LRB: Last received bit monitor           
        	//----------------------------------------------------------//
        	//****** Master non-ACK for last byte **********************//
        	//----------------------------------------------------------//
				//SBI0DBR = 0;                             // Write the dummy data (0x00) to the SBI0DBR to set SBI0CR2<PIN> to "1"
				SBI0CR2 = 0x58;                          // PIN = 1
			    SBI0CR2 = 0x18;                          // TRX = 0
            }
            else{
				SBI0DBR = wBuf[Flow.iByte];
				Flow.iByte++;			
            }
        }
    } 
       
}






